<!-- 订单管理-我的履约-手动执行 -->
<template>
    <app-drawer title="手动执行" :width="480" v-model:show="show" :loading="loading" :refresh="refresh">
        <el-form ref="formRef" label-width="60px" :model="formData" :rules="formRules">
            <el-form-item>
                <span>是否执行当前步骤【{{ getStepTypeName(selectedRow.steptypeid) }}】？</span>
            </el-form-item>
            <el-form-item label="备注" prop="StepRemark">
                <el-input type="textarea" :rows="3" v-model="formData.StepRemark" />
            </el-form-item>
        </el-form>
        <template #footer>
            <el-button @click="onCancel(false)" plain>取消</el-button>
            <el-button type="primary" @click="onSubmit">确认</el-button>
        </template>
    </app-drawer>
</template>

<script lang="ts" setup>
import { ref, PropType } from 'vue'
import { ElMessage } from 'element-plus'
import type { FormInstance, FormRules } from 'element-plus'
import { getStepTypeName } from '@/constants/order'
import { usePerformanceManual } from '@/business/order'
import AppDrawer from '@pc/components/base/drawer/index.vue'

const props = defineProps({
    selectedRow: {
        type: Object as PropType<Ermcp.MyPerformancRsp>,
        default: () => ({})
    }
})

const { loading, formData, formSubmit } = usePerformanceManual(props.selectedRow)
const show = ref(true)
const refresh = ref(false)
const formRef = ref<FormInstance>()

const formRules: FormRules = {
    StepRemark: [{ required: true, message: '请输入备注', trigger: 'blur' }],
}

const onCancel = (isRefresh = false) => {
    show.value = false
    refresh.value = isRefresh
}

const onSubmit = () => {
    formRef.value?.validate((valid) => {
        if (valid) {
            formSubmit().then(() => {
                ElMessage.success('提交成功')
                onCancel(true)
            }).catch((err) => {
                ElMessage.error('提交失败：' + err)
            })
        }
    })
}
</script>